﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

// Used so I can use Floor
using System;

public class Link2 : MonoBehaviour {

	// Speed Link moves
	public float speed;

	// Used to move Link
	private Rigidbody2D rb;

	// Used to change Link animations
	Animator animator;

	GameObject weaponGO;
	GameObject swordGO;

	public enum AttkDir
	{
		LEFT, RIGHT, UP, DOWN
	}

	// NEW STUFF MAKE PUBLIC
	public AttkDir atkDir;
	GameObject boomerangGO;
	// END OF NEW STUFF

	// Makes sure components have been created when the 
	// game starts
	void Awake(){
		// Get Links Rigidbody
		rb = GetComponent<Rigidbody2D> ();

		// Get Animator reference
		animator = GetComponent<Animator>();

		weaponGO = GameObject.Find("Weapon");
		swordGO = GameObject.Find("Sword");

		// Turns off the Sword
		swordGO.GetComponent<Renderer>().enabled = false;

		// NEW STUFF

		boomerangGO = GameObject.Find("Boomerang");
		boomerangGO.GetComponent<Renderer>().enabled = false;

		// END OF NEW STUFF
	}

	void FixedUpdate(){

		// Get keyboard input
		float horzMove = Input.GetAxisRaw ("Horizontal");
		float vertMove = Input.GetAxisRaw ("Vertical");

		rb.velocity = new Vector2 (horzMove * speed, vertMove * speed);

		if (Input.GetKey ("w") || Input.GetKey ("s")) {
			if (Input.GetKey ("s")) {

				animator.Play ("WalkDown");

				// Set attack direction to down and call for animation
				atkDir = AttkDir.DOWN;

			}

			if (Input.GetKey ("w")) {

				animator.Play ("WalkUp");

				// Set attack direction to up and call for animation
				atkDir = AttkDir.UP;

			}
		} else {

			if (Input.GetKey ("d")) {

				animator.Play ("WalkRight");

				atkDir = AttkDir.RIGHT;


			}

			if (Input.GetKey ("a")) {

				// NEW 2 Updated by adding WalkLeft
				animator.Play ("WalkLeft");

				// Set attack direction to left and call for animation
				atkDir = AttkDir.LEFT;

			}
		}

		// Switches back to the Idle position if a key is released
		if (Input.GetKeyUp ("s")) {

			animator.Play ("Idle");

			// When stopped Link will move back into a valid position
			float centerX = (float)Math.Round(Convert.ToDouble(transform.position.x));
			float centerY = (float)Math.Round(Convert.ToDouble(transform.position.y));

			transform.position = new Vector2(centerX, centerY);

			swordGO.GetComponent<Renderer>().enabled = false;

		}

		// Trigger sword attack with return key
		if (Input.GetKey (KeyCode.Return)) {

			LinkAttack ();

		}

		// NEW STUFF 1 FIRE BOOMERANG

		if (Input.GetKey ("m")) {

			StartCoroutine (BoomerangAttack ());

		}
			

	}

	IEnumerator BoomerangAttack(){

		switch (atkDir) {

		case AttkDir.DOWN:
			{
				// Show Boomerang
				boomerangGO.GetComponent<Renderer>().enabled = true;

				// Allow for the animator to animate
				boomerangGO.GetComponent<Animator> ().enabled = true;

				// Play animation
				boomerangGO.GetComponent<Animator>().Play("BoomerangDown");

				// Animate for 1.2 seconds
				yield return new WaitForSeconds(1.2f);

				// Disable animator and renderer
				boomerangGO.GetComponent<Animator> ().enabled = false;
				boomerangGO.GetComponent<Renderer>().enabled = false;
				break;

			}

		case AttkDir.LEFT:
			{

				boomerangGO.GetComponent<Renderer>().enabled = true;
				boomerangGO.GetComponent<Animator> ().enabled = true;
				boomerangGO.GetComponent<Animator>().Play("BoomerangLeft");
				yield return new WaitForSeconds(1.2f);
				boomerangGO.GetComponent<Animator> ().enabled = false;
				boomerangGO.GetComponent<Renderer>().enabled = false;
				break;

			}

		case AttkDir.RIGHT:
			{

				boomerangGO.GetComponent<Renderer>().enabled = true;
				boomerangGO.GetComponent<Animator> ().enabled = true;
				boomerangGO.GetComponent<Animator>().Play("BoomerangRight");
				yield return new WaitForSeconds(1.2f);
				boomerangGO.GetComponent<Animator> ().enabled = false;
				boomerangGO.GetComponent<Renderer>().enabled = false;
				break;

			}

		case AttkDir.UP:
			{

				boomerangGO.GetComponent<Renderer>().enabled = true;
				boomerangGO.GetComponent<Animator> ().enabled = true;
				boomerangGO.GetComponent<Animator>().Play("BoomerangUp");
				yield return new WaitForSeconds(1.2f);
				boomerangGO.GetComponent<Animator> ().enabled = false;
				boomerangGO.GetComponent<Renderer>().enabled = false;
				break;

			}


		}

	}

	// END OF NEW STUFF 1
		
	void LinkAttack(){

		switch (atkDir) {

		case AttkDir.DOWN:
			{
				StartCoroutine (AnimateSword (0f, 0f));
				break;
			}

		case AttkDir.LEFT:
			{
				StartCoroutine (AnimateSword (-90f, -.55f));
				break;
			}

		case AttkDir.RIGHT:
			{
				StartCoroutine (AnimateSword (90f, 0f));
				break;
			}

		case AttkDir.UP:
			{
				StartCoroutine (AnimateSword (180f, 0f));
				break;
			}

		}

	}

	IEnumerator AnimateSword(float rotation, float vertMove){

		// Make sword appear
		swordGO.GetComponent<Renderer>().enabled = true;

		// Rotate sword into position
		weaponGO.transform.rotation = Quaternion.Euler(0, 0, rotation);

		// Move sword vertically
		weaponGO.transform.position = new Vector3(transform.position.x, 
			transform.position.y + vertMove, transform.position.z);

		// Wait a second before hiding sword again
		yield return new WaitForSeconds (.2f);
		swordGO.GetComponent<Renderer>().enabled = false;


	}

}
